"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default_features = exports.Chassis = exports.static_assets = exports.redirect = exports.redact = exports.local_file = exports.encrypt = exports.decrypt = exports.api_config = exports.apidocs = exports.apis = exports.UMA = exports.webhooks = exports.textual = exports.render = exports.ua = exports.prometheus = exports.remote_config = exports.KeycloakPlugin = exports.harden = exports.cors = exports.BlobsPlugin = exports.amqp = void 0;
/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
const core = require("api-service-core");
const plugins_1 = require("./plugins");
var plugins_2 = require("./plugins");
Object.defineProperty(exports, "amqp", { enumerable: true, get: function () { return plugins_2.amqp; } });
Object.defineProperty(exports, "BlobsPlugin", { enumerable: true, get: function () { return plugins_2.BlobsPlugin; } });
Object.defineProperty(exports, "cors", { enumerable: true, get: function () { return plugins_2.cors; } });
Object.defineProperty(exports, "harden", { enumerable: true, get: function () { return plugins_2.harden; } });
Object.defineProperty(exports, "KeycloakPlugin", { enumerable: true, get: function () { return plugins_2.KeycloakPlugin; } });
Object.defineProperty(exports, "remote_config", { enumerable: true, get: function () { return plugins_2.remote_config; } });
Object.defineProperty(exports, "prometheus", { enumerable: true, get: function () { return plugins_2.prometheus; } });
Object.defineProperty(exports, "ua", { enumerable: true, get: function () { return plugins_2.ua; } });
Object.defineProperty(exports, "render", { enumerable: true, get: function () { return plugins_2.render; } });
Object.defineProperty(exports, "textual", { enumerable: true, get: function () { return plugins_2.textual; } });
Object.defineProperty(exports, "webhooks", { enumerable: true, get: function () { return plugins_2.webhooks; } });
Object.defineProperty(exports, "UMA", { enumerable: true, get: function () { return plugins_2.UMA; } });
const middleware_1 = require("./middleware");
var middleware_2 = require("./middleware");
Object.defineProperty(exports, "apis", { enumerable: true, get: function () { return middleware_2.apis; } });
Object.defineProperty(exports, "apidocs", { enumerable: true, get: function () { return middleware_2.apidocs; } });
Object.defineProperty(exports, "api_config", { enumerable: true, get: function () { return middleware_2.api_config; } });
Object.defineProperty(exports, "decrypt", { enumerable: true, get: function () { return middleware_2.decrypt; } });
Object.defineProperty(exports, "encrypt", { enumerable: true, get: function () { return middleware_2.encrypt; } });
Object.defineProperty(exports, "local_file", { enumerable: true, get: function () { return middleware_2.local_file; } });
Object.defineProperty(exports, "redact", { enumerable: true, get: function () { return middleware_2.redact; } });
Object.defineProperty(exports, "redirect", { enumerable: true, get: function () { return middleware_2.redirect; } });
Object.defineProperty(exports, "static_assets", { enumerable: true, get: function () { return middleware_2.static_assets; } });
var api_service_core_1 = require("api-service-core");
Object.defineProperty(exports, "Chassis", { enumerable: true, get: function () { return api_service_core_1.Chassis; } });
/*
        Register all our default plugins
        These can are installed before the server starts listening
 */
let default_plugins = function () {
    this.registerPlugin(new plugins_1.amqp());
    this.registerPlugin(new plugins_1.BlobsPlugin());
    this.registerPlugin(new plugins_1.cors());
    this.registerPlugin(new plugins_1.harden());
    this.registerPlugin(new plugins_1.KeycloakPlugin());
    this.registerPlugin(new plugins_1.UMA());
    this.registerPlugin(new plugins_1.prometheus());
    this.registerPlugin(new plugins_1.ua());
    this.registerPlugin(new plugins_1.render());
    this.registerPlugin(new plugins_1.remote_config());
    this.registerPlugin(new plugins_1.textual());
    this.registerPlugin(new plugins_1.webhooks());
    this.registerPlugin(new core.PipelinePlugin());
    this.registerPlugin(new core.after());
    this.registerPlugin(new core.before());
    this.registerPlugin(new core.logging());
    this.registerPlugin(new core.jwt());
    this.registerPlugin(new core.payload());
    this.registerPlugin(new core.OpenAPIPlugin());
};
/*
        Register all our middleware plugins
        These can be attached as chassis:operations to Open API specs
 */
let default_middleware = function () {
    this.registerFn(new core.bower_components());
    this.registerFn(new core.debug());
    this.registerFn(new core.DataDict());
    this.registerFn(new core.echo());
    this.registerFn(new core.gregarious());
    this.registerFn(new core.heartbeat());
    this.registerFn(new core.headers());
    this.registerFn(new core.mock());
    this.registerFn(new core.emit());
    this.registerFn(new core.not_found());
    this.registerFn(new core.request_uuid());
    this.registerFn(new core.sortby());
    this.registerFn(new middleware_1.api());
    this.registerFn(new middleware_1.apis());
    this.registerFn(new middleware_1.apidocs());
    this.registerFn(new middleware_1.decrypt());
    this.registerFn(new middleware_1.dexss());
    this.registerFn(new middleware_1.encrypt());
    this.registerFn(new middleware_1.local_file());
    this.registerFn(new middleware_1.api_config());
    this.registerFn(new middleware_1.redact());
    this.registerFn(new middleware_1.redirect());
    this.registerFn(new middleware_1.static_assets());
};
function default_features() {
    default_plugins.apply(this);
    default_middleware.apply(this);
}
exports.default_features = default_features;
//# sourceMappingURL=index.js.map