"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helmet = require("helmet");
const _ = require("lodash");
/**
 * Harden
 * ------
 * Feature to protect micro-service from request-side abuse
 * Essentially configures Helmet:
 *
 * For options, see: https://helmetjs.github.io/docs/
 *
 *  {
     *      harden:
     *          helmet-options
     *  }
 * @param context
 * @param options
 * @returns {exports}
 */
class harden {
    constructor() {
        this.name = "harden";
        this.title = "harden requests with Helmet";
    }
    install(context, options) {
        context.app.disable('x-powered-by');
        context.app.use(helmet(options));
        context.log({ code: "api:plugin:harden", message: "chassis hardened", options: _.keys(options) });
    }
}
exports.default = harden;
//# sourceMappingURL=harden.js.map